<?xml version="1.0" encoding="UTF-8"?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core"
	  xmlns:o="http://omnifaces.org/ui">
<ui:composition>
	<h:panelGroup styleClass="ui comments" layout="block">
		<div class="ui dividing header">
			Comments
		</div>
		<div class="ui accordion">
			<div class="title">
				<i class="dropdown icon"></i>
				Add a comment
			</div>
			<div class="content">
				<h:form id="addCommentFormId"
						styleClass="ui ${errorUtils.formClass(component)} form">
					<div class="field">
						<label>Display name</label>
						<h:inputText value="#{postCommentsBean.author}"
									 validatorMessage="Author name should not be that large; 255 symbols would be enough">
							<f:passThroughAttribute name="placeholder"
													value="Your name, please"/>
							<f:validateLength maximum="${postCommentsBean.maxAuthorLength}"/>
						</h:inputText>
					</div>
					<div class="important field">
						<label>Last name</label>
						<h:inputText value="#{postCommentsBean.hiddenField}"/>
					</div>
					<h:panelGroup layout="block" styleClass="field">
						<o:graphicImage value="${captchaImages.image()}" alt="Captcha" dataURI="true"
										rendered="${captchaHolder.required}"
										onclick="$('#addCommentFormId\\:refreshCaptchaButtonId').click();"/>
						<div class="ui left pointing small label ${captchaHolder.required ? '' : 'hidden'}">
							Five chars, click for new one, sorry for the inconvenience
						</div>
						<h:commandButton id="refreshCaptchaButtonId"
										 styleClass="hidden"
										 action="#{captchaHolder.create}"
										 immediate="true">
							<f:ajax execute="@form" render=":addCommentFormId"/>
						</h:commandButton>
						<h:inputText validator="#{captchaValidator.validate}"
									 styleClass="${captchaHolder.required ? '' : 'hidden'}">
							<f:passThroughAttribute name="placeholder" value="Captcha text"/>
						</h:inputText>
					</h:panelGroup>
					<div class="field">
						<label>Comment text</label>
						<h:inputTextarea value="#{postCommentsBean.content}"
										 onkeyup="forceSubmit(event, '#addCommentFormId\\:addCommentButtonId');"
										 validatorMessage="Telling us nothing would be weird; also brevity is the soul of wit">
							<f:passThroughAttribute name="placeholder"
													value="Here comes your comment"/>
							<f:validateRequired/>
							<f:validateLength maximum="${postCommentsBean.maxContentLength}"/>
						</h:inputTextarea>
					</div>
					<div class="ui error message">
						<h:messages showDetail="true" showSummary="false"/>
					</div>
					<h:commandButton id="addCommentButtonId"
									 styleClass="ui primary button"
									 value="Submit"
									 action="#{postCommentsBean.addComment}">
						<f:ajax execute="@form" render=":commentsListId :addCommentFormId"/>
					</h:commandButton>
				</h:form>
			</div>
		</div>
		<div class="ui divider"/>
		<h:form id="commentsListId">
			<ui:repeat value="${blogUtils.comments(postViewBean.article)}" var="comment">
				<div class="comment">
					<div class="content">
						<div class="author ${comment.owners ? 'owner' : ''}">
							${comment.author}
						</div>
						<div class="metadata">
							Created
							<h:outputText styleClass="local-date-time"
										  value="${comment.posted.toInstant().toEpochMilli()}"/>
						</div>
						<div class="text prewrap">
							<h:outputText value="${comment.content}"/>
						</div>
						<h:panelGroup styleClass="actions"
									  rendered="${currentUser.admin}"
									  layout="block">
							<h:commandLink value="Mark mine"
										   action="#{postCommentsBean.markMine(comment.id)}">
								<f:ajax render=":commentsListId"/>
							</h:commandLink>
							<h:commandLink value="Unmark mine"
										   action="#{postCommentsBean.unmarkMine(comment.id)}">
								<f:ajax render=":commentsListId"/>
							</h:commandLink>
							<h:commandLink value="Remove"
										   action="#{postCommentsBean.remove(comment.id)}">
								<f:ajax render=":commentsListId"/>
							</h:commandLink>
						</h:panelGroup>
					</div>
				</div>
			</ui:repeat>
		</h:form>
	</h:panelGroup>
</ui:composition>
</html>
